package adminbenefactorvalidator

import (
	"errors"

	param "git.gocasts.ir/ebhomengo/niki/param/admin/benefactor"
	errmsg "git.gocasts.ir/ebhomengo/niki/pkg/err_msg"
	richerror "git.gocasts.ir/ebhomengo/niki/pkg/rich_error"
	validation "github.com/go-ozzo/ozzo-validation/v4"
)

func (v Validator) ValidateGetAll(req param.BenefactorGetAllRequest) (map[string]string, error) {
	const op = "adminbenefactorvalidator.ValidateGetAll"

	validFields := []string{"id", "first_name", "last_name", "phone_number", "email", "status", "created_at"}

	if err := validation.ValidateStruct(&req,
		validation.Field(&req.Filter, validation.By(v.AreFilterFieldsValid(validFields))),
		validation.Field(&req.Sort, validation.By(v.AreSortFieldsValid(validFields))),
		validation.Field(&req.Search, validation.By(v.AreSearchValid())),
	); err != nil {

		fieldErrors := make(map[string]string)

		var errV validation.Errors
		if errors.As(err, &errV) {
			for key, value := range errV {
				if value != nil {
					fieldErrors[key] = value.Error()
				}
			}
		}

		return fieldErrors, richerror.New(op).
			WithMessage(errmsg.ErrorMsgInvalidInput).
			WithKind(richerror.KindInvalid).
			WithMeta(map[string]interface{}{"req": req}).
			WithErr(err)
	}

	return map[string]string{}, nil
}
